Class | Test::Unit::Collector::Dir
In: | test/unit/collector/dir.rb
Parent: | Object

### Methods

collect collect_file find_test_cases new recursive_collect

### Included Modules

Collector

### Attributes

exclude | [R] |
pattern | [R] |

### Public Class methods

new(dir=::Dir, file=::File, object_space=::ObjectSpace, req=nil)

[Source]

    # File test/unit/collector/dir.rb, line 12
            def initialize(dir=::Dir, file=::File, object_space=::ObjectSpace, req=nil)
              super()
              @dir = dir
              @file = file
              @object_space = object_space
              @req = req
              @pattern = [/\btest_.*\.rb\Z/m]
              @exclude = []
            end

### Public Instance methods

collect(*from)

[Source]

    # File test/unit/collector/dir.rb, line 22
            def collect(*from)
              if(from.empty?)
                recursive_collect('.', find_test_cases)
              elsif(from.size == 1)
                recursive_collect(from.first, find_test_cases)
              else
                suites = []
                from.each do |f|
                  suite = recursive_collect(f, find_test_cases)
                  suites << suite unless(suite.tests.empty?)
                end
                suite = TestSuite.new("[#{from.join(', ')}]")
                sort(suites).each{|s| suite << s}
                suite
              end
            end

collect_file(name, suites, already_gathered)

[Source]

    # File test/unit/collector/dir.rb, line 77
            def collect_file(name, suites, already_gathered)
              dir = File.dirname(File.expand_path(name))
              $:.unshift(dir)
              if(@req)
                @req.require(name)
              else
                require(name)
              end
              find_test_cases(already_gathered).each{|t| add_suite(suites, t.suite)}
            ensure
              $:.delete_at($:.rindex(dir)) if(dir)
            end

find_test_cases(ignore=[])

[Source]

    # File test/unit/collector/dir.rb, line 39
            def find_test_cases(ignore=[])
              cases = []
              @object_space.each_object(Class) do |c|
                cases << c if(c < TestCase && !ignore.include?(c))
              end
              ignore.concat(cases)
              cases
            end

recursive_collect(name, already_gathered)

[Source]

    # File test/unit/collector/dir.rb, line 48
            def recursive_collect(name, already_gathered)
              sub_suites = []
              if(@file.directory?(name))
                @dir.entries(name).each do |e|
                  next if(e == '.' || e == '..')
                  e_name = @file.join(name, e)
                  if(@file.directory?(e_name))
                    next if /\ACVS\z/ =~ e
                    sub_suite = recursive_collect(e_name, already_gathered)
                    sub_suites << sub_suite unless(sub_suite.empty?)
                  else
                    next if /~\z/ =~ e_name or /\A\.\#/ =~ e
                    if @pattern and !@pattern.empty?
                      next unless @pattern.any? {|pat| pat =~ e_name}
                    end
                    if @exclude and !@exclude.empty?
                      next if @exclude.any? {|pat| pat =~ e_name}
                    end
                    collect_file(e_name, sub_suites, already_gathered)
                  end
                end
              else
                collect_file(name, sub_suites, already_gathered)
              end
              suite = TestSuite.new(@file.basename(name))
              sort(sub_suites).each{|s| suite << s}
              suite
            end

[Validate]